# -----------------------------------------------------------------------------
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-Acken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Copyright (c) 1997/8 by Matthias Klusch, Torsten Vielhak
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# coala_checks:
# various "syntax" checks

# coala_float:
# checks if the argument is a float
proc coala_float {arg} {
    if {[regexp {^-?[0-9]+$} $arg] || [regexp {^-?[0-9]+\.[0-9]+} $arg]} {
	return 1
    } else {
	return 0
    }
}

# coala_positive_float:
# checks if the argument is a positive float
proc coala_positive_float {arg} {
    if {[regexp {^[0-9]+$} $arg] || [regexp {^[0-9]+\.[0-9]+} $arg]} {
    	if {$arg == 0} {
		return 0
	}
	return 1
    } else {
	return 0
    }
}

# coala_int:
# checks if the argument is an integer (>=0)
proc coala_int {arg} {
    if {[regexp {^[0-9]+$} $arg]} {
	return 1
    } else {
	return 0
    }
}

# coala_positive_int:
# checks if the argument is a positive integer (>0)
proc coala_positive_int {arg} {
    if {[regexp {^[0-9]+$} $arg]} {
    	if {$arg == 0} {
		return 0
	}
	return 1
    } else {
	return 0
    }
}

