# -----------------------------------------------------------------------------
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-A|cken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Copyright (c) 1997/8 by Matthias Klusch, Torsten Vielhak
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

proc coala_display_neg_dyn_event {} {
    global c_font

    set w .analyze
    destroy $w.f2

    # ===== make "new" special frame
    frame $w.f2  -relief ridge -bd 2
    pack $w.f2 -side top -fill x -in $w.right

    frame $w.f2.f1
    pack $w.f2.f1 -in $w.f2 -fill x -side top
    label $w.f2.l1 -text "Select Agents"
    pack $w.f2.l1 -in $w.f2.f1 -side top -fill x
    coala_bind_help $w.f2.l1 "coala_shorthelp ana1_lb_dyn_event.hlp"

    frame $w.f2.f2
    pack $w.f2.f2 -in $w.f2 -fill x -side top
    scrollbar $w.f2.scroll1 -command "$w.f2.c_list yview"
    listbox $w.f2.c_list -yscroll "$w.f2.scroll1 set" \
		-relief raised -exportselection no -height 10 -width 14 -selectmode extended  
    coala_bind_help $w.f2.c_list "coala_shorthelp ana1_lb_dyn_event.hlp"
    pack $w.f2.c_list -side left -fill both -expand 1 -in $w.f2.f2
    pack $w.f2.scroll1 -side right -fill y -in $w.f2.f2


	bind $w.f2.c_list <ButtonRelease-1> {
		global a_agents
		set sel_agents {}
		foreach ag_num [.analyze.f2.c_list curselection] {
			lappend sel_agents [lindex $a_agents $ag_num]
		}
		coala_delete_infounits_dyn_events
		coala_draw_infounits_dyn_events $sel_agents
	}

	frame $w.f2.f3
	pack $w.f2.f3 -in $w.f2 -fill x -side top
	coala_correct_round_num
	set agents [coala_read_dyn_event]
	# ==== fill list 
	foreach agent $agents {
		$w.f2.c_list insert end $agent
    }
    # ===== adjust widths
    coala_check_list $w.f2.c_list 14
	# ===== select the first agent 
	$w.f2.c_list selection set 0 end
	coala_paint_dyn_event $agents
}

proc coala_read_dyn_event {} {
	global r_new_agent r_extra_tasks r_leaving_agent r_cancled_tasks r_already_left r_waiting_agent
	catch {
		unset r_new_agent
	}
	catch {
		unset r_extra_tasks
	}
	catch {
		unset r_leaving_agent
	}
	catch {
		unset r_cancled_tasks
	}
	catch {
		unset r_already_left
	}
	catch {
		unset r_waiting_agent
	}

	global a_agents rnd_coal_struct already_left
	global simulation_name selected_neg round_num show_all_agents

	set show_all_agents 0
	set logfile [open "logs/$simulation_name\.$selected_neg\.log" r]
	# ==== find the lines for dynamic events
	while {![eof $logfile]} {
		gets $logfile line
		if {$line != "round [expr $round_num]"} {
			continue
		}

		while {![eof $logfile]} {
	   		gets $logfile line
			if {[lindex $line 0] != "dagents"} {
				continue
			}
			set a_agents [lreplace $line 0 0]
			gets $logfile line
			set rnd_coal_struct [lreplace $line 0 0]
			if {$show_all_agents} {
				gets $logfile line
				set already_left [lreplace $line 0 0]
				foreach agent $already_left {
					set r_already_left($agent) 1
				}
				set rnd_coal_struct [concat $rnd_coal_struct $already_left]
			}
			break
		}
		break
	}

	# ===== read dynamic events
	global no_dyn_events
	set no_dyn_events 1
	while {![eof $logfile]} {
   		gets $logfile line
		if {$line == "dynamic_events"} {
			while {![eof $logfile]} {
		   		gets $logfile line
				if {$line == "end_of_dynamic_events"} {
					break
				}
				set no_dyn_events 0
				set agent [lindex $line 1]
				switch [lindex $line 0] {
					1 {
						# leaving agent
						set r_leaving_agent($agent) 1
					}

					2 {	
						# new agent
						lappend rnd_coal_struct $agent
						lappend a_agents $agent
						set r_new_agent($agent) 1
					}

					3 { 
						# new infos
						if {$show_all_agents || ([lsearch $a_agents $agent] > -1 && [lsearch $a_agents [lindex $line 2]] > -1)} {
							lappend r_extra_tasks($agent) [list [lindex $line 2] [lindex $line 3]]
						}
					}

					4 { 
						# cancled infos
						if {$show_all_agents || ([lsearch $a_agents $agent] > -1 && [lsearch $a_agents [lindex $line 2]] > -1)} {
							lappend r_cancled_tasks($agent) [list [lindex $line 2] [lindex $line 3]]
						}
					}
				}		
			}
			break
		}
	}
	
	
#	if {$show_all_agents} {
		# ==== agents waiting for entering into the negotiation
#		gets $logfile line
#		set waiting_agent [lreplace $line 0 0]
#		foreach agent $waiting_agent {
#			set r_waiting_agent($agent) 1
#		}
#		set rnd_coal_struct [lsort [concat $rnd_coal_struct $waiting_agent]]
#		set a_agents [lsort [concat $a_agents $waiting_agent]]
#	}
	close $logfile
	return $a_agents
}

proc coala_paint_dyn_event {agents} {
	set w .analyze

	# ===== clear canvas
	eval .analyze.canvas delete [.analyze.canvas find all]

	global no_dyn_events c_font
	global round_num selected_neg

	if $no_dyn_events {
		.analyze.canvas create text 10 10 -text " " -anchor w -font $c_font
		.analyze.canvas create text 200 300 -text "There's No Dynamic Event at Round $round_num of Negotiation $selected_neg" \
			-anchor w -font $c_font
		return
	}

    global agent_xpos agent_ypos a_agents agent_width agent_height

	# ===== sizes for agents, ....
	set agent_width 100
	set agent_height 50
    set scale 1.0
    
	set pi 3.1415927
	set radius [expr int([llength $a_agents] / 5.0 * $agent_height * 2.5)]
	set center_x [expr 40 + $radius]
	set center_y [expr 120 + $radius]
	set angle_per_agent [expr 2 * $pi / [llength $a_agents]]

	set i 0
	foreach agent $a_agents {
	    set agent_xpos($agent) [expr int(cos([expr 3.1415927+$angle_per_agent*$i])*$radius)+$center_x]
	    set agent_ypos($agent) [expr int(sin([expr 3.1415927+$angle_per_agent*$i])*$radius)+$center_y]
		incr i 1
	}

	global agent_xpos agent_ypos real_agent_xpos real_agent_ypos rnd_coal_struct 
	global mpressed ids_for_coal other_obj_ids_for_coal 
	global a_agents  
	global r_new_agent r_extra_tasks r_leaving_agent r_cancled_tasks r_already_left r_waiting_agent

	if [info exists ids_for_coal] {
		unset ids_for_coal
	}
	if [info exists other_obj_ids_for_coal] {
		unset other_obj_ids_for_coal
	}

	set mpressed 0

	# ===== title for the canvas
	.analyze.canvas create text 10 10 -text "Dynamic Events at Round $round_num of Negotiation $selected_neg" \
		-anchor w -font $c_font
    coala_bind_help .analyze.canvas "coala_shorthelp ana1_dg_dyn_event.hlp"

	coala_display_color_explanation_for_dyn_event

	# ===== clear connections list 
	catch {
		unset connections
	}

	# ===== calculate coalitions/agent positions
	foreach coal $rnd_coal_struct {
		set repr_agent [lindex $coal 0]
		set xpos $agent_xpos($repr_agent)
		set ypos $agent_ypos($repr_agent)

		foreach agent $coal {
			set real_agent_xpos($agent) $xpos
			set real_agent_ypos($agent) $ypos
			# ===== next agent for this coalition
			incr xpos $agent_width			 
		}
	}

	global infos 

	# ===== paint coalitions and infos
	foreach coal $rnd_coal_struct {
		foreach agent $coal {
			# ====== paint box foreach agent
			set xpos $real_agent_xpos($agent)
			set ypos $real_agent_ypos($agent)

			set a_color white
			if [info exists r_new_agent($agent)] {
				# ===== new agent
				set a_color lightblue
			}
			if [info exists r_leaving_agent($agent)] {
				# ===== leaving agent
				set a_color orange
			}
			if [info exists r_already_left($agent)] {
				# ===== leaving agent
				set a_color red
			}
			if [info exists r_waiting_agent($agent)] {
				# ===== leaving agent
				set a_color yellow
			}

			set id [$w.canvas create rectangle $xpos $ypos [expr $xpos + $agent_width] [expr $ypos + $agent_height] -fill $a_color]
			$w.canvas lower $id

			lappend ids_for_coal($coal) $id
		 
			# ===== bind mouse button (for dragging the coalitions)
			$w.canvas bind $id <Button-1> "global mpressed, sel_coal, round_num, sel_round; set mpressed 1; set sel_round $round_num; set sel_coal [list $coal]"
			$w.canvas bind $id <ButtonRelease-1> {
				global mpressed sel_coal
				if {$mpressed} {
					global a_agents
					set sel_agents {}
					foreach ag_num [.analyze.f2.c_list curselection] {
						lappend sel_agents [lindex $a_agents $ag_num]
					}
					coala_draw_infounits_dyn_events $sel_agents
					# ===== adjust scrollregion
					coala_adjust_analyze_canvas
				}
				set mpressed 0
			}

			$w.canvas bind $id <Motion> {
				global mpressed sel_coal
		
				# ====== mouse move and a coalition is selected
				if {$mpressed} { 
					global agent_xpos agent_ypos 

					# ===== get representative for the selected coalition
					set agent [lindex $sel_coal 0]
					set xpos $real_agent_xpos($agent)
					set ypos $real_agent_ypos($agent)
			  
					# ===== move every widget that belongs to the selected coalition
					global ids_for_coal other_obj_ids_for_coal
					foreach id $ids_for_coal($sel_coal) {
						.analyze.canvas move $id [expr [.analyze.canvas canvasx %x] - $xpos] [expr [.analyze.canvas canvasy %y] - $ypos] 
					}
					# ==== delete all lines connected to sel_coal
					if [info exists other_obj_ids_for_coal($sel_coal)] {
						foreach id $other_obj_ids_for_coal($sel_coal) {
							.analyze.canvas delete $id 
						}
					}
					set other_obj_ids_for_coal($sel_coal) {}
					# ===== remember new position
					set real_agent_xpos($agent) [expr int([.analyze.canvas canvasx %x])]		  
					set real_agent_ypos($agent) [expr int([.analyze.canvas canvasy %y])]
					set xpos $real_agent_xpos($agent)
					set ypos $real_agent_ypos($agent)
					
					foreach agent $sel_coal {
						set real_agent_xpos($agent) $xpos
						set real_agent_ypos($agent) $ypos
						# ===== next agent for this coalition
						incr xpos $agent_width			 
					}

					# ===== adjust scrollregion
					coala_adjust_analyze_canvas
				} 
			}


			# ===== write the name of the agent into it
			set id [$w.canvas create text [expr $xpos + ($agent_width /2)] [expr $ypos + 8] -text $agent \
				-anchor c -justify center -font $c_font] 
			lappend ids_for_coal($coal) $id

			if ![info exists infos($agent)] {
				continue
			}
		}
	}
	coala_draw_infounits_dyn_events $agents


	# ===== find bounding box for all items in the canvas
	set xmin 100000
	set ymin 100000
	set xmax -100000
	set ymax -100000
    
	foreach id [.analyze.canvas find all] {
		if {[lindex [.analyze.canvas coords $id] 0] < $xmin} {
			set xmin [lindex [.analyze.canvas coords $id] 0]
		}		   
		if {[lindex [.analyze.canvas coords $id] 0] > $xmax} {
			set xmax [lindex [.analyze.canvas coords $id] 0]
		}
		if {[lindex [.analyze.canvas coords $id] 1] < $ymin} {
			set ymin [lindex [.analyze.canvas coords $id] 1]
		}
		if {[lindex [.analyze.canvas coords $id] 1] > $ymax} {
			set ymax [lindex [.analyze.canvas coords $id] 1]
		}
	}
    
	# ===== margins
	set ymax [expr $ymax + 30]

	# ===== adjust scrollregion
	coala_adjust_analyze_canvas
}

proc coala_draw_infounits_dyn_events {agents} {
	global real_agent_xpos real_agent_ypos other_obj_ids_for_coal a_agents rnd_coal_struct
	global r_extra_tasks r_cancled_tasks agent_height agent_width infos

	foreach agent $a_agents {
		set coal [coala_get_coal_of_agent_in_struct $agent $rnd_coal_struct]
		# ===== paint the infounits and lines between agents
		set xpos $real_agent_xpos($agent)
		set ypos $real_agent_ypos($agent)
		set xp 4
		set yp 20
		set info_id 0
		foreach entry $infos($agent) {
			set must_before [.analyze.canvas create oval [expr $xp+$xpos] [expr $yp+$ypos] [expr $xp+$xpos+14] [expr $yp+$ypos+14] -fill black]
			lappend other_obj_ids_for_coal($coal) $must_before
			set id [.analyze.canvas create text [expr $xp+$xpos+7] [expr $yp+$ypos+8] -text [lindex $entry 0] -fill white -anchor center -justify center]
			lappend other_obj_ids_for_coal($coal) $id
			
			foreach agent2 $a_agents {
				if {[lsearch $agents $agent2] == -1} {
					continue
				}
				set drawing 0
				if [info exists r_extra_tasks($agent2)] {
					foreach e_tasks $r_extra_tasks($agent2) {
						if {[lindex $e_tasks 0] != $agent} {
							continue
						}
						if {[lindex $e_tasks 1] != $info_id} {
							continue
						}
						set drawing 1
						set line_color blue
					}
				}
				if {[info exists r_cancled_tasks($agent2)] && !$drawing} {
					foreach e_tasks $r_cancled_tasks($agent2) {
						if {[lindex $e_tasks 0] != $agent} {
							continue
						}
						if {[lindex $e_tasks 1] != $info_id} {
							continue
						}
						set drawing 1
						set line_color red
					}
				}
				
				if !$drawing {
					continue
				}					
				
				if {$real_agent_ypos($agent2) >= [expr $yp+$ypos]} {
					if {[expr $real_agent_ypos($agent2) - [expr $yp+$ypos]] < $agent_height} {
						set lineid [.analyze.canvas create line [expr $real_agent_xpos($agent2)+$xp+7] $real_agent_ypos($agent2) \
										[expr ($xp+$xpos+7+$real_agent_xpos($agent2)+$xp)/2] [expr $yp+$ypos-2*$agent_height] \
										[expr $xp+$xpos+7] [expr $yp+$ypos+7] \
										-arrow first -width 2 -smooth 1 -splinesteps 10 -fill $line_color]
					} else {
						set lineid [.analyze.canvas create line [expr $real_agent_xpos($agent2)+$xp+7] $real_agent_ypos($agent2) \
										[expr $xp+$xpos+7] [expr $yp+$ypos+7] \
										-arrow first -width 2 -fill $line_color]
					}
				} else {
					if {[expr - $real_agent_ypos($agent2) + [expr $yp+$ypos]] < 2*$agent_height} {
						set lineid [.analyze.canvas create line [expr $real_agent_xpos($agent2)+$xp+7] \
										[expr $real_agent_ypos($agent2)+$agent_height] \
										[expr ($xp+$xpos+7+$real_agent_xpos($agent2)+$xp)/2] \
										[expr $real_agent_ypos($agent2)+2*$agent_height] \
										[expr $xp+$xpos+7] [expr $yp+$ypos+7] \
										-arrow first -smooth 1 -splinesteps 10  -width 2 -fill $line_color]
					} else {
						set lineid [.analyze.canvas create line [expr $real_agent_xpos($agent2)+$xp+7]\
										[expr $real_agent_ypos($agent2)+$agent_height] \
										[expr $xp+$xpos+7] [expr $yp+$ypos+7] -arrow first -width 2 -fill $line_color]
					}
				}
				.analyze.canvas lower $lineid $must_before
				lappend other_obj_ids_for_coal($coal) $lineid
				if {[lsearch $coal $agent2] == -1} {
					set o_coal [coala_get_coal_of_agent_in_struct $agent2 $rnd_coal_struct]
					lappend other_obj_ids_for_coal($o_coal) $lineid
				}
			}
			incr xp 18
			if {$xp >= 138} {
				set xp 4
				incr yp 16
			}
			incr info_id
		}
	}
}

proc coala_delete_infounits_dyn_events {} {
	global other_obj_ids_for_coal rnd_coal_struct

	foreach coal $rnd_coal_struct {
		# ==== delete all lines connected to sel_coal
		foreach id $other_obj_ids_for_coal($coal) {
			.analyze.canvas delete $id 
		}
		set $other_obj_ids_for_coal($coal) {}
	}
}

proc coala_display_color_explanation_for_dyn_event {} {
	global show_all_agents round_num c_font

	set g_colors {white lightblue orange red yellow}
	set dyn_text(0) "Agent which still stays in Negotiation"
	set dyn_text(1) "Agent which comes at Round $round_num" 
	set dyn_text(2) "Agent which leaves Negotiation at Round $round_num"
	set dyn_text(3) "Agent which already left Negotiation before Round $round_num" 
	set dyn_text(4) "Agent which may come later"
	set dyn_text(5) "Info-Unit with Price n"
	set dyn_text(6) "Info-Unit becomes Relevant at Round $round_num"
	set dyn_text(7) "Info-Unit becomes Irrelevant at Round $round_num"

	set expl_from_x 470
	set expl_from_y 5
#    .analyze.canvas create text $expl_from_x 5 -text "Color Explanation" -font $c_font -anchor nw
	set to_i 3
	if {$show_all_agents} {
		set to_i 5
	}
	for {set i 0} {$i < $to_i} {incr i} {
		.analyze.canvas create rectangle $expl_from_x [expr $expl_from_y + $i * 20] [expr $expl_from_x + 20] [expr $expl_from_y + 18 + $i * 20] \
			-fill [lindex $g_colors $i] 
	    .analyze.canvas create text [expr $expl_from_x + 25] [expr $i * 20 + $expl_from_y + 2] -text $dyn_text($i) \
			-font $c_font -anchor nw
	}

	if {!$show_all_agents} {
		set expl_from_y -35
	}
	.analyze.canvas create oval [expr $expl_from_x + 3] [expr $expl_from_y + 102] [expr $expl_from_x + 17] [expr $expl_from_y + 116] -fill black
	.analyze.canvas create text [expr $expl_from_x + 10] [expr $expl_from_y + 108] -text n -fill white -anchor center -justify center
    .analyze.canvas create text [expr $expl_from_x + 25] [expr $expl_from_y + 102] -text $dyn_text(5) -font $c_font -anchor nw
	
	.analyze.canvas create line $expl_from_x [expr $expl_from_y + 130] [expr $expl_from_x + 20] [expr $expl_from_y + 130] \
		-arrow last -width 2 -fill blue
    .analyze.canvas create text [expr $expl_from_x + 25] [expr $expl_from_y + 122] -text $dyn_text(6) -font $c_font -anchor nw
	.analyze.canvas create line $expl_from_x [expr $expl_from_y + 150] [expr $expl_from_x + 20] [expr $expl_from_y + 150] -arrow last -width 2 -fill red
    .analyze.canvas create text [expr $expl_from_x + 25] [expr $expl_from_y + 142] -text $dyn_text(7) -font $c_font -anchor nw
}
