# -----------------------------------------------------------------------------
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-Acken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Copyright (c) 1997/8 by Matthias Klusch, Torsten Vielhak
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

proc coala_display_neg_trust_rating {} {
    global c_font

    set w .analyze
    destroy $w.f1
    destroy $w.f2
    # ===== make "new" special frame
    frame $w.f1
    pack $w.f1 -side top -fill x -in $w.right
    
    # ====== frames
    frame $w.f1.f11 
    frame $w.f1.f12 -relief ridge -bd 2

	pack $w.f1.f11 -side top -fill x -in $w.f1 
	pack $w.f1.f12 -side top -fill y -in $w.f1 


    label $w.f1.l1 -text "Select Agent"
    pack $w.f1.l1 -fill x -side top -in $w.f1.f11

    scrollbar $w.f1.scroll1 -command "$w.f1.a_list yview"
    listbox $w.f1.a_list -yscroll "$w.f1.scroll1 set" \
		-relief raised -exportselection no -height 15 -width 16 
    
    pack $w.f1.a_list -side left -fill both -expand 1 -in $w.f1.f12
    pack $w.f1.scroll1 -side right -fill y -in $w.f1.f12
    coala_bind_help $w.f1.a_list "coala_shorthelp ana1_lb_trust_rating.hlp"


	bind $w.f1.a_list <ButtonRelease-1> {
		coala_draw_neg_trust_rating
	}

    # ===== fill lists
	global simulation_name selected_neg
    global participant

	set logfile [open "logs/$simulation_name\.$selected_neg\.log" r]
	while {![eof $logfile]} {
   		gets $logfile line
		if {[lindex $line 0] == "Participant"} {
			set participant [lreplace $line 0 0]
			break
		}
	}
	close $logfile
    foreach agent $participant {
		$w.f1.a_list insert end $agent
    }

    # ===== adjust widths
    coala_check_list $w.f1.a_list 16
	# ===== select the first agent 
	$w.f1.a_list selection set 0

    # ===== show trust rating
    coala_draw_neg_trust_rating
}

proc coala_read_neg_trust_rating {} {
	global participant selected_neg by_uvalues to_uvalues simulation_name
	global min_by_uvalue max_by_uvalue

	set s_agent [lindex $participant [.analyze.f1.a_list curselection]]
	set min_by_uvalue 0
	set max_by_uvalue 0
	# ===== read trust rating by 's_agent' to others 
	set logfile [open "logs/$simulation_name\.trust$s_agent\.log" r]
	set by_uvalues {}
	foreach o_agent $participant {
		if {$s_agent == $o_agent} {
			continue
		}
		while {![eof $logfile]} {
	    	gets $logfile line
			if {$o_agent != [lindex $line 0]} {
				continue
			}
			set trust_list [lreplace $line 0 0]
			break
		}

		set pre_trust [lindex $trust_list 0]
		set pre_uvalue [lindex $pre_trust 1]
		set trust_list [lreplace $trust_list 0 0]
		foreach trust $trust_list {
			if {$trust == ""} {
				break
			}
			if {$selected_neg != [lindex $trust 0]} {
				set pre_uvalue [lindex $trust 1]
			} else {
				set uvalue [lindex $trust 1]
				lappend by_uvalues [list $o_agent $pre_uvalue $uvalue]
				break
			}
		}
		if {$pre_uvalue < $min_by_uvalue} {
			set min_by_uvalue $pre_uvalue
		}
		if {$pre_uvalue > $max_by_uvalue} {
			set max_by_uvalue $pre_uvalue
		}
		if {$uvalue < $min_by_uvalue} {
			set min_by_uvalue $uvalue
		}
		if {$uvalue > $max_by_uvalue} {
			set max_by_uvalue $uvalue
		}
	}
	close $logfile
	set min_by_uvalue [expr floor($min_by_uvalue)]
	set max_by_uvalue [expr ceil($max_by_uvalue)]
	if {[expr $max_by_uvalue - $min_by_uvalue] <= 1} {
		set min_by_uvalue -1
		set max_by_uvalue 1
	}

	# ===== read trust rating by others to 's_agent' 
	global min_to_uvalue max_to_uvalue
	set min_to_uvalue 0
	set max_to_uvalue 0
	set to_uvalues {}
	foreach o_agent $participant {
		if {$s_agent == $o_agent} {
			continue
		}
		set logfile [open "logs/$simulation_name\.trust$o_agent\.log" r]
		while {![eof $logfile]} {
	    	gets $logfile line
			if {$s_agent != [lindex $line 0]} {
				continue
			}
			set trust_list [lreplace $line 0 0]
			break
		}
		close $logfile

		set pre_trust [lindex $trust_list 0]
		set pre_uvalue [lindex $pre_trust 1]
		set trust_list [lreplace $trust_list 0 0]
		foreach trust $trust_list {
			if {$trust == ""} {
				break
			}
			if {$selected_neg != [lindex $trust 0]} {
				set pre_uvalue [lindex $trust 1]
			} else {
				set uvalue [lindex $trust 1]
				lappend to_uvalues [list $o_agent $pre_uvalue $uvalue]
				break
			}
		}
		if {$pre_uvalue < $min_to_uvalue} {
			set min_to_uvalue $pre_uvalue
		}
		if {$pre_uvalue > $max_to_uvalue} {
			set max_to_uvalue $pre_uvalue
		}
		if {$uvalue < $min_to_uvalue} {
			set min_to_uvalue $uvalue
		}
		if {$uvalue > $max_to_uvalue} {
			set max_to_uvalue $uvalue
		}
	}
	set min_to_uvalue [expr floor($min_to_uvalue)]
	set max_to_uvalue [expr ceil($max_to_uvalue)]
	if {[expr $max_to_uvalue - $min_to_uvalue] <= 1} {
		set min_to_uvalue -1
		set max_to_uvalue 1
	}
}

# ====== draws trust rating for negotiation  
proc coala_draw_neg_trust_rating {} {
    global c_font selected_neg participant by_uvalues to_uvalues
	global min_by_uvalue max_by_uvalue

	coala_read_neg_trust_rating

    # ===== clear canvas
    eval .analyze.canvas delete [.analyze.canvas find all]
    .analyze.canvas create text 10 10 -text "Change of Trust Ratings after Negotiation $selected_neg" -font $c_font -anchor w
    coala_bind_help .analyze.canvas "coala_shorthelp ana1_dg_trust_rating.hlp"

	set s_agent [lindex $participant [.analyze.f1.a_list curselection]]
	# ===== draw trust rating by 's_agent' to others 
	# ===== set basic geometry value
	set x_left 10
	set x_gab 90
	set x_start	[expr $x_left + $x_gab / 2]
	set y_bottom 255
	set y_top 85
	set g_width 37
	set g_start_y [expr $y_bottom - ($y_bottom - $y_top) * (abs($min_by_uvalue) + 0.0) / ($max_by_uvalue - $min_by_uvalue)]
	set unit_height [expr ($y_bottom - $y_top) * 1.0 / ($max_by_uvalue - $min_by_uvalue)]

    .analyze.canvas create text 10 30 -text "Trust Ratings by $s_agent to Other Participants" -font $c_font -anchor w
	# ===== draw axis
    .analyze.canvas create line $x_left $g_start_y [expr $x_left + ([llength $participant] - 1) * $x_gab] $g_start_y -width 2 

	set i 0
	foreach o_uvalue_info $by_uvalues {
		set o_agent [lindex $o_uvalue_info 0]
		set pre_uvalue [format "%.3f" [lindex $o_uvalue_info 1]]
		set post_uvalue [format "%.3f" [lindex $o_uvalue_info 2]]
		.analyze.canvas create text [expr $x_start + $i * $x_gab] [expr $y_top - 25] -text $o_agent -font $c_font 
		.analyze.canvas create rectangle [expr $x_start + $i * $x_gab - $g_width] $g_start_y \
			[expr $x_start + $i * $x_gab] [expr $g_start_y - $pre_uvalue * $unit_height] -fill red 
		if {$pre_uvalue >= 0} {
			.analyze.canvas create text [expr $x_start + $i * $x_gab - $g_width / 2] \
				[expr $g_start_y - $pre_uvalue * $unit_height - 8] -text $pre_uvalue -font $c_font 
		} else {
			.analyze.canvas create text [expr $x_start + $i * $x_gab - $g_width / 2] \
				[expr $g_start_y - $pre_uvalue * $unit_height + 8] -text $pre_uvalue -font $c_font 
		} 
		.analyze.canvas create rectangle [expr $x_start + $i * $x_gab] $g_start_y \
			[expr $x_start + $i * $x_gab + $g_width] [expr $g_start_y - $post_uvalue * $unit_height] -fill blue 
		if {$post_uvalue >= 0} {
			.analyze.canvas create text [expr $x_start + $i * $x_gab + $g_width / 2] \
				[expr $g_start_y - $post_uvalue * $unit_height - 8] -text $post_uvalue -font $c_font 
		} else {
			.analyze.canvas create text [expr $x_start + $i * $x_gab + $g_width / 2] \
				[expr $g_start_y - $post_uvalue * $unit_height + 8] -text $post_uvalue -font $c_font 
		} 
		incr i
	}

	# ===== draw trust rating by others to 's_agent' 
	global min_to_uvalue max_to_uvalue

	# ===== set basic geometry value
	set graph2_ypos [expr $y_bottom + 40]
	set y_bottom [expr $y_bottom + $graph2_ypos]
	set y_top [expr $y_top + $graph2_ypos]
	set g_width 37
	set g_start_y [expr $y_bottom - ($y_bottom - $y_top) * (abs($min_to_uvalue) + 0.0) / ($max_to_uvalue - $min_to_uvalue)]
	set unit_height [expr ($y_bottom - $y_top) * 1.0 / ($max_to_uvalue - $min_to_uvalue)]

    .analyze.canvas create text 10 [expr 30 + $graph2_ypos] -text "Trust Ratings by Other Participants to $s_agent" -font $c_font -anchor w
	# ===== draw axis
    .analyze.canvas create line $x_left $g_start_y [expr $x_left + ([llength $participant] - 1) * $x_gab] $g_start_y -width 2 

	set i 0
	foreach o_uvalue_info $to_uvalues {
		set o_agent [lindex $o_uvalue_info 0]
		set pre_uvalue [format "%.3f" [lindex $o_uvalue_info 1]]
		set post_uvalue [format "%.3f" [lindex $o_uvalue_info 2]]
		.analyze.canvas create text [expr $x_start + $i * $x_gab] [expr $y_top - 25] -text $o_agent -font $c_font 
		.analyze.canvas create rectangle [expr $x_start + $i * $x_gab - $g_width] $g_start_y \
			[expr $x_start + $i * $x_gab] [expr $g_start_y - $pre_uvalue * $unit_height] -fill red 
		if {$pre_uvalue >= 0} {
			.analyze.canvas create text [expr $x_start + $i * $x_gab - $g_width / 2] \
				[expr $g_start_y - $pre_uvalue * $unit_height - 8] -text $pre_uvalue -font $c_font 
		} else {
			.analyze.canvas create text [expr $x_start + $i * $x_gab - $g_width / 2] \
				[expr $g_start_y - $pre_uvalue * $unit_height + 8] -text $pre_uvalue -font $c_font 
		} 
		.analyze.canvas create rectangle [expr $x_start + $i * $x_gab] $g_start_y \
			[expr $x_start + $i * $x_gab + $g_width] [expr $g_start_y - $post_uvalue * $unit_height] -fill blue 
		if {$post_uvalue >= 0} {
			.analyze.canvas create text [expr $x_start + $i * $x_gab + $g_width / 2] \
				[expr $g_start_y - $post_uvalue * $unit_height - 8] -text $post_uvalue -font $c_font 
		} else {
			.analyze.canvas create text [expr $x_start + $i * $x_gab + $g_width / 2] \
				[expr $g_start_y - $post_uvalue * $unit_height + 8] -text $post_uvalue -font $c_font 
		} 
		incr i
	}
	
    # ====== adjust scrollregion
    coala_adjust_analyze_canvas
}
 

