# -----------------------------------------------------------------------------$)C
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-A|cken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# ===== changes the display type to reputation rating
proc coala_display_sim_reputation_rating {} {

	set w .analyze
	destroy $w.f1

	# ===== make "new" special frame
	frame $w.f1
	pack $w.f1 -fill x -in $w.right
	
	# ====== frames
	frame $w.f1.f11 
	frame $w.f1.f12 
	frame $w.f1.f12_1 -relief ridge -bd 2
	frame $w.f1.f12_2 -relief ridge -bd 2

	pack $w.f1.f11 -side top -fill x -in $w.f1 
	pack $w.f1.f12 -side bottom -fill x -in $w.f1 
	pack $w.f1.f12_1 -side left -fill y -in $w.f1.f12 
	pack $w.f1.f12_2 -side right -fill y  -in $w.f1.f12


	label $w.f1.l1 -text "Reputation Rating"
	pack $w.f1.l1 -fill x -side top -in $w.f1.f11

	# ==== listbox for "by"
	label $w.f1.l2 -text "By"
	scrollbar $w.f1.scroll1 -command "$w.f1.by_list yview"
	listbox $w.f1.by_list -yscroll "$w.f1.scroll1 set" \
		-relief raised -exportselection no -height 20 -width 5 -selectmode extended
	
	pack $w.f1.l2 -fill x -side top -in $w.f1.f12_1
	pack $w.f1.by_list -side left -fill both -expand 1 -in $w.f1.f12_1
	pack $w.f1.scroll1 -side right -fill y -in $w.f1.f12_1
    coala_bind_help $w.f1.l2 "coala_shorthelp ana2_lb_reputation_rating_by.hlp"
    coala_bind_help $w.f1.by_list "coala_shorthelp ana2_lb_reputation_rating_by.hlp"

	bind $w.f1.by_list <ButtonRelease-1> {
		coala_draw_reputation_rating
	}

	# ==== listbox for "to"
	label $w.f1.l3 -text "To"
	scrollbar $w.f1.scroll2 -command "$w.f1.to_list yview"
	listbox $w.f1.to_list -yscroll "$w.f1.scroll2 set" \
		-relief raised -exportselection no -height 20 -width 5 -selectmode extended
	
	pack $w.f1.l3 -fill x -side top -in $w.f1.f12_2
	pack $w.f1.to_list -side left -fill both -expand 1 -in $w.f1.f12_2
	pack $w.f1.scroll2 -side right -fill y -in $w.f1.f12_2
    coala_bind_help $w.f1.l3 "coala_shorthelp ana2_lb_reputation_rating_to.hlp"
    coala_bind_help $w.f1.to_list "coala_shorthelp ana2_lb_reputation_rating_to.hlp"

	bind $w.f1.to_list <ButtonRelease-1> {
		coala_draw_reputation_rating
	}
   
	# ===== fill lists
	global agents_list
	foreach agent $agents_list {
		$w.f1.by_list insert end $agent
		$w.f1.to_list insert end $agent
	}

	# ===== adjust widths
	coala_check_list $w.f1.by_list 5
	coala_check_list $w.f1.to_list 5
	# ===== select agent (by default : a_1, a_2)
	$w.f1.by_list selection set 0
	$w.f1.to_list selection set 1

	# ===== show reputation rating
	coala_draw_reputation_rating
}

# ====== draws reputation rating	  
proc coala_draw_reputation_rating {} {
	global c_font agents_list simulation_name

	# ==== get max, min reputation rating
	set max_uvalue 0
	set min_uvalue 0
	set all_reputation_list {}
	foreach by_agent_no [.analyze.f1.by_list curselection] {
		set logfile [open "logs/$simulation_name\.reputation[lindex $agents_list $by_agent_no]\.log" r]
		foreach to_agent_no [.analyze.f1.to_list curselection] {
			if {$by_agent_no == $to_agent_no} {
				continue
			}
			while {![eof $logfile]} {
				gets $logfile line
				if {$line == ""} {
					continue
				}
				if {[lindex $agents_list $to_agent_no] != [lindex $line 0]} {
					continue
				}
				set tmp_reputation_list [lreplace $line 0 0]
				foreach util_n $tmp_reputation_list {
					set uvalue [lindex $util_n 1]
					if {$max_uvalue < $uvalue} {
						set max_uvalue $uvalue
					}
					if {$min_uvalue > $uvalue} {
						set min_uvalue $uvalue
					}
				}
				set reputation_list [lreplace $line 0 0 [list [lindex $agents_list $by_agent_no] [lindex $agents_list $to_agent_no]]]
				break
			}
			lappend all_reputation_list $reputation_list
		}
		close $logfile
	}


	# ===== clear canvas
	eval .analyze.canvas delete [.analyze.canvas find all]
	.analyze.canvas create text 10 20 -text "Development of Reputation Rating" -font $c_font -anchor nw
    coala_bind_help .analyze.canvas "coala_shorthelp ana2_dg_reputation_rating.hlp"

	# ===== draw axis
	set x_left	60
	set x_right 560
	set y_bottom 450
	set y_top 50

	.analyze.canvas create line $x_left $y_top $x_left $y_bottom -width 2
	.analyze.canvas create line $x_left $y_bottom $x_right $y_bottom -width 2
	# ===== adjust scale
	set max_int [expr int([expr ceil($max_uvalue)])]
	set min_int [expr int([expr floor($min_uvalue)])]
	if {$max_int != 0 && $min_int != 0} {
		.analyze.canvas create line $x_left [expr $y_top + abs($max_int) * ($y_bottom - $y_top) / ($max_int - $min_int)] \
			$x_right [expr $y_top + abs($max_int) * ($y_bottom - $y_top) / ($max_int - $min_int)] -width 1 -fill #ffffff
	}

	if {$max_int == $min_int} {
		# ==== max_int = min_int = 0
		set int_diff 2
		set max_int 1
		set min_int -1
	} else {
		set int_diff [expr $max_int - $min_int]
	} 
		
	set j 0
	for {set i $max_int} {$i >= $min_int} {set i [expr $i - $int_diff / 10.0]} { 
		if {$i == [expr int($i)]} {
			.analyze.canvas create text [expr $x_left - 15] [expr $y_top + $j * ($y_bottom - $y_top) / 10] \
				-text [expr int($i)] -font $c_font
		} else {
			.analyze.canvas create text [expr $x_left - 15] [expr $y_top + $j * ($y_bottom - $y_top) / 10] \
				-text $i -font $c_font
		}
		.analyze.canvas create line $x_left [expr $y_top + $j * ($y_bottom - $y_top) / 10] [expr $x_left + 3] \
			[expr $y_top + $j * ($y_bottom - $y_top) / 10] -width 2
		incr j
	}


	global opt_sim
	set total_neg_no [lindex $opt_sim 0]
	set j 0
	for {set i 0} {$i < 11} {incr i} { 
		.analyze.canvas create text [expr $x_left + $i * ($x_right - $x_left) / 10] [expr $y_bottom + 10] \
			-text [expr $i * $total_neg_no / 10] -font $c_font
		.analyze.canvas create line [expr $x_left + $i * ($x_right - $x_left) / 10] $y_bottom \
			[expr $x_left + $i * ($x_right - $x_left) / 10] [expr $y_bottom - 3] -width 2
	}
	.analyze.canvas create text [expr ($x_left + $x_right) / 2 - 10] [expr $y_bottom + 25] -text "Negotiation Number" -font $c_font
	.analyze.canvas create text [expr $x_right + 80] 50 -text "By" -font $c_font
	.analyze.canvas create text [expr $x_right + 115] 50 -text "To" -font $c_font


	# ====== draw graphs
	global agents_list simulation_name 

	set colorfile [open "rgb.txt" r]
	set cnt 1
	foreach reputation_of_two_agents $all_reputation_list {
		set agents_pair [lindex $reputation_of_two_agents 0]
		set pair_index "[lindex $agents_pair 0][lindex $agents_pair 1]"
		set reputation_list [lreplace $reputation_of_two_agents 0 0]
		# ===== set color
		gets $colorfile line
		if {$line != ""} {
			set r [lindex $line 0]
			set g [lindex $line 1]
			set b [lindex $line 2]
			set rgb [format "%02x%02x%02x" $r $g $b]
		} else {
			set rgb [format "%02x%02x%02x" 0 0 0]
		}

		set ini_reputation [lindex $reputation_list 0]
		set neg_no [lindex $ini_reputation 0]
		set uvalue [lindex $ini_reputation 1]
		set reputation_list [lreplace $reputation_list 0 0]
		set from_x $x_left
		set from_y [expr $y_bottom - ($uvalue - $min_int) * ($y_bottom - $y_top) / $int_diff] 

		foreach reputation $reputation_list {
			if {$reputation == ""} {
				break
			}
			set neg_no [lindex $reputation 0]
			set uvalue [lindex $reputation 1]
			set to_x [expr $x_left + $neg_no * ($x_right - $x_left) / $total_neg_no]
			set to_y [expr $y_bottom - ($uvalue - $min_int) * ($y_bottom - $y_top) / $int_diff] 
			.analyze.canvas create line $from_x $from_y $to_x $to_y -width 2 -fill #$rgb -tags $pair_index
			set from_x $to_x
			set from_y $to_y
		}
		if {$neg_no != $total_neg_no} {
			set to_x [expr $x_left + $total_neg_no * ($x_right - $x_left) / $total_neg_no]
			set to_y [expr $y_bottom - ($uvalue - $min_int) * ($y_bottom - $y_top) / $int_diff] 
			.analyze.canvas create line $from_x $from_y $to_x $to_y -width 2 -fill #$rgb -tags $pair_index
		}
		.analyze.canvas create text [expr $x_right + 80] [expr $cnt * 15 + 50] -text [lindex $agents_pair 0] -font $c_font
		.analyze.canvas create text [expr $x_right + 115] [expr $cnt * 15 + 50] -text [lindex $agents_pair 1] -font $c_font
		.analyze.canvas create line [expr $x_right + 30] [expr $cnt * 15 + 50] [expr $x_right + 60] \
			[expr $cnt * 15 + 50] -width 2 -fill #$rgb -tags $pair_index
		incr cnt

		.analyze.canvas bind $pair_index <Button-1> {
			set item_id [.analyze.canvas find withtag current]
			set tag_id [lindex [.analyze.canvas gettags $item_id] 0]
			.analyze.canvas itemconfigure $tag_id -width 6
		}
		.analyze.canvas bind $pair_index <ButtonRelease-1> {
			set item_id [.analyze.canvas find withtag current]
			set tag_id [lindex [.analyze.canvas gettags $item_id] 0]
			.analyze.canvas itemconfigure $tag_id -width 2
		}
	}
	close $colorfile
	
	# ====== adjust scrollregion
	coala_adjust_analyze_canvas
}



