# -----------------------------------------------------------------------------
# Copyright (c) 1997/8 by Matthias Klusch, Torsten Vielhak
# Computer Science Department,
# Christian-Albrechts-University of Kiel,
# Olshausenstr. 40, 24118 Kiel, Germany
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the CAU Kiel
# without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# ===== coala_shorthelp
# ===== opens a small window with the given help-text (filename)

proc coala_shorthelp {filename} {
    set w .dialog2

    # ===== remember old grab
    global old_grab
    set old_grab [grab current]

    catch {destroy $w}
  
    toplevel $w -class Dialog
   
    # ===== hide window
    wm withdraw $w

    wm title $w "COALA Help"
    wm iconname $w "COALA Help"
    
    frame $w.f1 -relief ridge -borderwidth 2
    pack $w.f1 -expand 1 -fill both
    
    text $w.text1 -yscrollcommand "$w.scroll1 set" 
    pack $w.text1 -fill both -expand 1 -in $w.f1 -side left
    
    scrollbar $w.scroll1 -command "$w.text1 yview"
    pack $w.scroll1 -in $w.f1 -side right -fill y

    button $w.ok -text "OK" -command {global old_grab; catch {grab $old_grab}; destroy .dialog2}
    pack $w.ok -fill x

    set content ""
    set links 0
    set first_line 1
    set file [open "help/$filename" r]
    while {![eof $file] && ! $links} {
	gets $file line
	if {$line != "---"} {
	    if {$first_line} {
		set content $line
		set first_line 0
	    } else {
		set content "$content\n$line"
	    }
	} else {
	    set links 1
	}
    }
    if {$links} {
	label $w.llinks -text "Related help texts:"
	pack $w.llinks -fill x -expand 1
	set nr 1
	gets $file text
	gets $file hlp_file
	while {$text != "---"} {
	    button $w.b_$nr -text $text -command "global old_grab; catch {grab $old_grab}; coala_shorthelp $hlp_file"
	    pack $w.b_$nr -fill x -expand 1
	    incr nr
	    gets $file text
	    gets $file hlp_file	    
	}
    }
    close $file
    
    $w.text1 insert end $content
    
    $w.text1 configure -state disabled

    wm deiconify $w
    tkwait visibility $w
    grab $w
}
