# -----------------------------------------------------------------------------
# Copyright (c) 2003/4 by Matthias Klusch, Wooseok Park
# Computer Science Department,
# University of Saarland,
# Postfach 151150, 66041 Saarbr-Acken, Germany$)C
# 
# All rights reserved.
# No warranties will be given on any issues arising out of the use
# of this software product.
# Permission to use, copy, modify and distribute this software
# product for non-commercial purposes is hereby granted, provided
# that the above copyright notice appears in all copies and
# respective publications.
# All commercial trades with this product outside the University of
# Saarland without specific written prior permission are prohibited.
#-----------------------------------------------------------------------------

# ===== default.tcl - default values of options in COALA
# ===== default values of options for info-units and search-tasks :
# ===== number of default info-units for each agent,
# ===== price of each default info-unit, 
# ===== accessible by (1 = all agents, 2 = only owner, 3 = none),
# ===== tasks for (1 = all agents, 2 = only owner, 3 = none),
global default_opt_info 
set default_opt_info {0 0 3 3}

# ===== default values of options for simulation :
# ===== number of negotiations,
# ===== max time for one negotiation (sec),
# ===== packet sending time (millisec),
# ===== algorithm (1 = BSCA-D, 2 = BSCA-T),
# ===== max number of proposals pro coalition,
# ===== coalition environment (1 = general, 2 = social), (for radiobutton),
# ===== random file option (1 = new generating, 2 = new generating and save, 3 = use file)
# ===== random file name
global default_opt_sim 
set default_opt_sim {50 5 100 1 2 1 1 none}

global default_opt_agent 
set default_opt_agent {0 0 0 0 0 0 0}
# ===== Text for options (using in dialogbox etc)
global opt_agent_text 
set opt_agent_text {"Number of Negotiations to Participate in as a Latecomer :" \
					"Number of Negotiations to Drop Out :" \
					"Number of Information-Units which are Relevant from the Beginning of a Negotiation :" \
					"Number of Information-Units which are becoming Irrelevant During a Negotiation :" \
					"Number of Information-Units which are becoming Relevant During a Negotiation :" \
					"Probation Period :" \
                    "Acts Maliciously :" }
                         
# ===== read values for preset from file coala_preset
global preset_opt_info preset_opt_agent 

# ===== test if preset file exists
if [file exists "coala_preset"] {
	# ===== open file 
	set file [open "coala_preset" r]

	# ===== read values 
	gets $file line
	set preset_opt_info $line
	gets $file line
	set preset_opt_agent $line
	close $file
} else {
	set preset_opt_info {1 2 1 1}
	set preset_opt_agent {1 1 3 0 1 2 0}
	# ===== write preset file
	set file [open "coala_preset" w]
	puts $file $preset_opt_info
	puts $file $preset_opt_agent
	close $file
}

